package com.fp.persistence.pgeneral.acco;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEACCONUMSTRUCTURE*/
@Embeddable
public class TgeneAccoNumStructureKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="STRUCTUREACCOUNTCATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo - EMPRESA, OFICINA, PRODUCTO, ETC.
*/
private String structureaccountcatalog;

@Column(name="STRUCTUREACCOUNTCATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo - FIELDSSTRUCTURE
*/
private String structureaccountcatalogcode;

/**Contructor por defecto*/
public TgeneAccoNumStructureKey(){}
/**Contructor de TgeneAccoNumStructureKey
@param pModulecode Codigo de modulo
@param pStructureaccountcatalog Codigo de catalogo - EMPRESA, OFICINA, PRODUCTO, ETC.
@param pStructureaccountcatalogcode Codigo de tabla de catalogo - FIELDSSTRUCTURE
*/
public TgeneAccoNumStructureKey(String pModulecode,String pStructureaccountcatalog,String pStructureaccountcatalogcode){
 modulecode=pModulecode;
 structureaccountcatalog=pStructureaccountcatalog;
 structureaccountcatalogcode=pStructureaccountcatalogcode;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de structureaccountcatalog
@return valor de structureaccountcatalog*/
public String getStructureaccountcatalog(){
  return structureaccountcatalog;
}
/**Fija el valor de structureaccountcatalog
@param pStructureaccountcatalog nuevo Valor de structureaccountcatalog*/
public void setStructureaccountcatalog(String pStructureaccountcatalog){
  structureaccountcatalog=pStructureaccountcatalog;
}

/**Obtiene el valor de structureaccountcatalogcode
@return valor de structureaccountcatalogcode*/
public String getStructureaccountcatalogcode(){
  return structureaccountcatalogcode;
}
/**Fija el valor de structureaccountcatalogcode
@param pStructureaccountcatalogcode nuevo Valor de structureaccountcatalogcode*/
public void setStructureaccountcatalogcode(String pStructureaccountcatalogcode){
  structureaccountcatalogcode=pStructureaccountcatalogcode;
}

/**Implementación de la comparación de TgeneAccoNumStructureKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneAccoNumStructureKey))return false;
  TgeneAccoNumStructureKey that = (TgeneAccoNumStructureKey) o;
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getStructureaccountcatalog() == null || that.getStructureaccountcatalog() == null){
      return false;
  }
  if (! this.getStructureaccountcatalog().equals(that.getStructureaccountcatalog())){
    return false;
  }
  if (this.getStructureaccountcatalogcode() == null || that.getStructureaccountcatalogcode() == null){
      return false;
  }
  if (! this.getStructureaccountcatalogcode().equals(that.getStructureaccountcatalogcode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneAccoNumStructureKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getStructureaccountcatalog() == null ? 0 : this.getStructureaccountcatalog().hashCode());
    result = result * 37 + (this.getStructureaccountcatalogcode() == null ? 0 : this.getStructureaccountcatalogcode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
